import {render} from "@testing-library/react-native";
import Home from "@/app/home";
import {PatientProvider} from "@/hooks/usePatient";

describe("Test Screens", () => {
    it("Renders Screens", () => {
        const tree = render(
            <PatientProvider value={{ patientID: 1 }}>
                <Home />
            </PatientProvider>
        ).toJSON();

        expect(tree).toMatchSnapshot();
    });

    it("Check Home List Headers", () => {
        const {getByText} = render(
            <PatientProvider value={{ patientID: 1 }}>
                <Home />
            </PatientProvider>
        );
        expect(getByText("Symptoms")).toBeTruthy();
        expect(getByText("Notifications")).toBeTruthy();
        expect(getByText("Medications")).toBeTruthy();
        expect(getByText("Appointments")).toBeTruthy();
    });
})