import {Link, Stack} from 'expo-router';
import {StyleProp, StyleSheet, Text, TextStyle, View} from 'react-native';

export default function NotFoundScreen() {

  const linkStyle: StyleProp<TextStyle> = {
    marginTop: 15,
    paddingVertical: 15,
  }

  return (
    <>
      <Stack.Screen options={{ title: 'Oops!' }} />
      <View style={styles.container}>
        <Text>This screen doesn't exist.</Text>
        <Link href="/index" style={linkStyle}>
          <Text>Go to home screen!</Text>
        </Link>
      </View>
    </>
  );
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center',
    padding: 20,
  },
});
