import {useColorScheme, View} from "react-native";
import React from 'react';
import MaterialIcons from "@expo/vector-icons/MaterialIcons";
import {pushLogin, pushRegister} from "@/constants/pushUser";
import {StatusBar} from "expo-status-bar";
import {Colors} from "@/constants/Colors";
import StyledButton from "@/components/StyledButton";
// https://venngage.com/tools/accessible-color-palette-generator

export default function Index() {
    const themeStyle = useColorScheme() === "dark" ? Colors.dark : Colors.light;

    return (
            <View style={themeStyle}>
                <StatusBar
                    backgroundColor={themeStyle.backgroundColor}
                />
                <View style={{flex: 1, justifyContent: "center"}}>
                    <MaterialIcons name={"login"} size={50} style={{alignSelf: "center"}}/>
                    <StyledButton
                        onPress={pushLogin}
                        buttonStyle={{backgroundColor: themeStyle.moveButton.backgroundColor}}
                        textStyle={{color: themeStyle.moveButton.color}}
                        text={"Login"}
                    />
                </View>
                <View style={{flex: 1}}>
                    <MaterialIcons name={"app-registration"} size={50} style={{alignSelf: "center"}}/>
                    <StyledButton
                        onPress={pushRegister}
                        buttonStyle={{backgroundColor: themeStyle.moveButton.backgroundColor}}
                        textStyle={{color: themeStyle.moveButton.color}}
                        text={"Sign Up"}
                    />
                </View>
            </View>
    );
}