import {StyleProp, StyleSheet, TextStyle, useColorScheme, View} from 'react-native';
import StyledButton from "@/components/StyledButton";
import {Colors} from "@/constants/Colors";

export function DoctorNav({ buttonText1, buttonText2, buttonText3, buttonFunction1, buttonFunction2, buttonFunction3, buttonStyle1, buttonStyle2, buttonStyle3 }) {
    const themeStyle = useColorScheme() === "dark" ? Colors.dark : Colors.light;
    const textStyle: StyleProp<TextStyle> = {
        fontSize: 16,
        color: themeStyle.color,
    };

    return (
        <View style={style.container}>
            <View style={style.column1}>
                <StyledButton
                    text={buttonText1}
                    onPress={buttonFunction1}
                    textStyle={textStyle}
                    buttonStyle={buttonStyle1}
                />
            </View>
            <View style={style.column2}>
                <StyledButton
                    text={buttonText2}
                    onPress={buttonFunction2}
                    textStyle={textStyle}
                    buttonStyle={buttonStyle2}
                />
            </View>
            <View style={style.column3}>
                <StyledButton
                    text={buttonText3}
                    onPress={buttonFunction3}
                    textStyle={textStyle}
                    buttonStyle={buttonStyle3}
                />
            </View>
        </View>
    );
}

const style = StyleSheet.create({
    container: {
        flexDirection: 'row',
        justifyContent: 'space-around',
        alignItems: 'center',
        marginBottom: 10,
        marginTop: 10,
    },
    column1: {
        flex: 1,
        justifyContent: 'center',
        alignItems: 'center',
    },
    column2: {
        flex: 1,
        justifyContent: 'space-between',
        alignItems: 'center',
    },
    column3: {
        flex: 1,
        justifyContent: 'center',
        alignItems: 'center',
    },
    text: {
        fontSize: 14,
    },
});