import {FlatList} from 'react-native';
import {useState} from "react";
import {usePatient} from "@/hooks/usePatient";
import {useFunction} from "@/constants/fetchData";
import {AppointmentCard} from "@/components/AppointmentCard";

export function ListAppoints({ column1, column2, dataPoint1, dataPoint2, dataPoint3, functionName}) {
    const {patientID} = usePatient();
    const [data, setData] = useState([]);
    useFunction(patientID, setData, functionName);
    return (
        <FlatList
            nestedScrollEnabled={true}
            data={data}
            renderItem={({ item }) => (
                <AppointmentCard
                    data1={item[column1]}
                    data2={item[column2]}
                    item1={item[dataPoint1]}
                    item2={item[dataPoint2]}
                    item3={item[dataPoint3]}
                    request={item["appointmentID"]}
                    cancel={item["appointmentID"]}
                />
            )}
            keyExtractor={(item, index) => index.toString()}
        />
    );
}