import {FlatList} from 'react-native';
import React, {useState} from "react";
import {usePatient} from "@/hooks/usePatient";
import {useFunction} from "@/constants/fetchData";
import {ContactCard} from "@/components/ContactCard";

export function ListContacts({image, dataPoint1, dataPoint2, dataPoint3, phoneNumber, functionName}) {
    const { patientID } = usePatient();
    const [data, setData] = useState([]);
    useFunction(patientID, setData, functionName);

    return (
        <FlatList
            nestedScrollEnabled={true}
            data={data}
            renderItem={({ item }) => (
                <ContactCard
                    image={image}
                    item1={item[dataPoint1]}
                    item2={item[dataPoint2]}
                    item3={item[dataPoint3]}
                    phoneNumber={item[phoneNumber]}
                />
            )}
            keyExtractor={(item, index) => index.toString()}
        />
    );
}