import {FlatList} from 'react-native';
import {useState} from "react";
import {usePatient} from "@/hooks/usePatient";
import {DocumentCard} from "@/components/DocumentCard";
import {useFunction} from "@/constants/fetchData";

export function ListDocuments({image, dataPoint1, dataPoint2, quantity, label, functionName}) {
    const { patientID } = usePatient();
    const [data, setData] = useState([]);
    useFunction(patientID, setData, functionName);

    return (
        <FlatList
            nestedScrollEnabled={true}
            data={data}
            renderItem={({ item }) => (
                <DocumentCard
                    image={image}
                    item1={item[dataPoint1]}
                    item2={item[dataPoint2]}
                    item3={item["documentFile"]}
                    quantity={item[quantity]}
                    label={label}
                />
            )}
            keyExtractor={(item, index) => index.toString()}
        />
    );
}