import {FlatList} from 'react-native';
import {useState} from "react";
import {usePatient} from "@/hooks/usePatient";
import {useFunction} from "@/constants/fetchData";
import {NotificationCard} from "@/components/NotificationCard";

export function ListNotifs({ image, date, time, dataPoint1, dataPoint2, functionName}) {
    const {patientID} = usePatient();
    const [data, setData] = useState([]);
    useFunction(patientID, setData, functionName);
    return (
        <FlatList
            nestedScrollEnabled={true}
            data={data}
            renderItem={({ item }) => (
                <NotificationCard
                    image={image}
                    date={item[date]}
                    time={item[time]}
                    item1={item[dataPoint1]}
                    item2={item[dataPoint2]}
                />
            )}
            keyExtractor={(item, index) => index.toString()}
        />
    );
}