import {FlatList} from 'react-native';
import {useState} from "react";
import {useDoctorFunction} from "@/constants/fetchData";
import {useDoctor} from "@/hooks/useDoctor";
import {Card} from "@/components/Card";

export function ListPatientCard({ image, column1, column2, dataPoint1, dataPoint2, dataPoint3, quantity, label, functionName}) {
    const {doctorID} = useDoctor();
    const [data, setData] = useState([]);
    useDoctorFunction(doctorID, setData, functionName);

    return (
        <FlatList
            nestedScrollEnabled={true}
            data={data}
            renderItem={({ item }) => (
                <Card
                    image={image}
                    data1={item[column1]}
                    data2={item[column2]}
                    item1={item[dataPoint1]}
                    item2={item[dataPoint2]}
                    item3={item[dataPoint3]}
                    quantity={item[quantity]}
                    label={label}
                />
            )}
            keyExtractor={(item, index) => index.toString()}
        />
    );
}