import {useEffect, useState} from "react";
import * as Location from "expo-location";
import {LocationObject} from "expo-location";

const LocationData = () => {
    const [location, setLocation] = useState<LocationObject | null>(null);
    const [errorMsg, setErrorMsg] = useState<string | null>(null);

    useEffect(() => {
        (async () => {
            let { status } = await Location.requestForegroundPermissionsAsync();
            if (status !== 'granted') {
                setErrorMsg('Permission to access location was denied');
                return;
            }

            let location = await Location.getCurrentPositionAsync({});
            setLocation(location);
        })();
    }, []);

    if (errorMsg) {
        window.alert("Location Denied.")
    } else if (location) {
        JSON.stringify(location);
    }

    return location;
};

export default LocationData;
