import {Pressable, StyleProp, Text, ViewStyle} from "react-native";

export default function StyledButton({buttonStyle, textStyle, onPress, disabled, text}) {

    const generalButtonStyle: StyleProp<ViewStyle> = {
        borderRadius: 10,
        alignItems: 'center',
        justifyContent: 'center',
        padding: "5%",
        margin: "5%",
    }

    const joinedButtonStyle = {...generalButtonStyle,...buttonStyle}

    return(
        <Pressable
            onPress={onPress}
            style={joinedButtonStyle}
            disabled={disabled}
        >
            <Text style={textStyle}>{text}</Text>
        </Pressable>
    )
}

