/**
 * Below are the colors that are used in the app. The colors are defined in the light and dark mode.
 * There are many other ways to style your app. For example, [Nativewind](https://www.nativewind.dev/), [Tamagui](https://tamagui.dev/), [unistyles](https://reactnativeunistyles.vercel.app), etc.
 */

const buttonStyles = {
  rescheduleButton: {
    backgroundColor: '#b7940b',
    color: 'black',
  },
  cancelButton: {
    backgroundColor: '#c92828',
    color: 'lightgray',
  },
  selectButton: {
    backgroundColor: '#4d8dbb',
    color: 'black',
  },
  moveButton: {
    backgroundColor: '#cb691a',
    color: 'black',
  },
  confirmButton: {
    backgroundColor: '#128f49',
    color: 'black',
  },
  textInput:{
    margin: 10,
    padding: 10,
    color: "black",
  },
  titleText: {
    fontWeight: "bold",
    alignSelf: "center",
    textDecorationLine: "underline",
    color: '#E3B505',
  },
  divider: {
    borderBottomColor: "black",
    borderBottomWidth: 1,
    marginVertical: 5,
  },
}

export const Colors  = {
  light: {
    flex: 1,
    backgroundColor: '#779ECB',
    color: '#2F4858',
    ...buttonStyles
  },
  dark: {
    flex: 1,
    backgroundColor: '#5A5A5A',
    color: '#f0ead6',
    ...buttonStyles
  },
};