import {fetchRequest} from "@/constants/fetchData";

export async function getPatientID(patientName) {
    const formData = new FormData();
    formData.append("action", "getPatientID");
    formData.append("patientName", patientName);
    return await fetchRequest(formData);
}

export async function insertDocument(patientID, doctorID, documentFile) {
    const formData = new FormData();
    formData.append("action", "insertPatientDocuments");
    formData.append("patientName", patientID);
    formData.append("doctorID", doctorID);
    formData.append("documentFile", documentFile);
    return await fetchRequest(formData);
}

export async function insertAppointment(patientID, doctorID, appointmentDate,appointmentTime,title,appointDescription) {
    const formData = new FormData();
    formData.append("action", "insertPatientAppointments");
    formData.append("patientName", patientID);
    formData.append("appointmentDate", appointmentDate);
    formData.append("appointmentTime", appointmentTime);
    formData.append("title", title);
    formData.append("appointDescription", appointDescription);
    return await fetchRequest(formData);
}

export async function insertMedication(patientID, doctorID, medicationName, strength, type, frequency, timeofday, medDescription) {
    const formData = new FormData();
    formData.append("action", "insertPatientMedications");
    formData.append("patientName", patientID);
    formData.append("doctorID", doctorID);
    formData.append("medicationName", medicationName);
    formData.append("strength", strength);
    formData.append("type", type);
    formData.append("frequency", frequency);
    formData.append("timeofday", timeofday);
    formData.append("medDescription", medDescription);
    return await fetchRequest(formData);
}

export async function insertNotifs(patientID, doctorID, notificationTime,subject,notifDescription) {
    const formData = new FormData();
    formData.append("action", "insertPatientNotifications");
    formData.append("patientName", patientID);
    formData.append("notificationTime", notificationTime);
    formData.append("subject", subject);
    formData.append("notifDescription", notifDescription);
    return await fetchRequest(formData);
}