<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, GET, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");

$servername = "devweb2023.cis.strath.ac.uk";
$username = "qrb21125";
$password = "le7ivioViBop";
$dbname = $username;

$conn = new mysqli($servername, $username, $password, $dbname);

if ($conn->connect_error) {
    echo json_encode(["success" => false, "message" => "Database connection failed: " . $conn->connect_error]);
    exit();
}

$input = $_POST;

$action = sanitize_input($conn, $input, 'action', null);
if (!$action) {
    echo json_encode(["success" => false, "message" => "No action specified. " . $action]);
    exit();
}

function sanitize_input($conn, $input, $key, $default = '') {
    return isset($input[$key]) ? $conn->real_escape_string(strip_tags($input[$key])) : $default;
}

$doctorID = sanitize_input($conn, $input, 'doctorID', null);
$patientID = sanitize_input($conn, $input, 'patientID', null);

$doctorName = sanitize_input($conn, $input, 'doctorName');
$doctorType = sanitize_input($conn, $input, 'doctorType');

$patientName = sanitize_input($conn, $input, 'patientName');
if (isset($_FILES['avatarPicture']) && $_FILES["avatarPicture"]["error"] == 0) {
    $tmpPath = $_FILES['avatarPicture']['tmp_name'];
    $avatarPicture = addslashes(file_get_contents($tmpPath));
} else {
    $avatarPicture = null;
}
$name = sanitize_input($conn, $input, 'name');
$username = sanitize_input($conn, $input, 'username');
$email = sanitize_input($conn, $input, 'email');
$email = sanitize_input($conn, $input, 'email');
$password = sanitize_input($conn, $input, 'password');
$phoneNumber = sanitize_input($conn, $input, 'phoneNumber');

$documentTitle = sanitize_input($conn, $input, 'documentTitle');
$documentDescription = sanitize_input($conn, $input, 'documentDescription');
$documentType = sanitize_input($conn, $input, 'documentType');
if (isset($_FILES['documentFile']) && $_FILES["documentFile"]["error"] == 0) {
    $tmpPath = $_FILES['documentFile']['tmp_name'];
    $documentFile = addslashes(file_get_contents($tmpPath));
} else {
    $documentFile = null;
}
$followUp = sanitize_input($conn, $input, 'followUp');

$symptomName = sanitize_input($conn, $input, 'symptomName');
$symptomDescription = sanitize_input($conn, $input, 'symptomDescription');
$symptomSeverity = sanitize_input($conn, $input, 'symptomSeverity');
$symptomFrequency = sanitize_input($conn, $input, 'symptomFrequency');
$startDate = sanitize_input($conn, $input, 'startDate');
$endDate = sanitize_input($conn, $input, 'endDate');
$symptomStatus = sanitize_input($conn, $input, 'symptomStatus');
$notes = sanitize_input($conn, $input, 'notes');

$appointmentID = sanitize_input($conn, $input, 'appointmentID', null);
$appointmentDate = sanitize_input($conn, $input, 'appointmentDate');
$appointmentTime = sanitize_input($conn, $input, 'appointmentTime');
$title = sanitize_input($conn, $input, 'title');
$appointDescription = sanitize_input($conn, $input, 'appointmentDescription');
$location = sanitize_input($conn, $input, 'location');
$status = sanitize_input($conn, $input, 'status');

$medicationName = sanitize_input($conn, $input, 'medicationName');
$strength = sanitize_input($conn, $input, 'strength');
$type = sanitize_input($conn, $input, 'type');
$frequency = sanitize_input($conn, $input, 'frequency');
$timeOfDay = sanitize_input($conn, $input, 'timeOfDay');
$medDescription = sanitize_input($conn, $input, 'medicationDescription');

$notificationTime = sanitize_input($conn, $input, 'notificationTime');
$subject = sanitize_input($conn, $input, 'subject');
$notifDescription = sanitize_input($conn, $input, 'notifDescription');

function noPatientID($patientID){
    if (!$patientID) {
        echo json_encode(["success" => false, "message" => "Patient ID is Needed."]);
        exit();
    }
}

function noEmailOrPassword($email, $password){
    if (!$email || !$password) {
        echo json_encode(["success" => false, "message" => "Email & Password are required."]);
        exit();
    }
}

function noSignUpInfo($name, $username, $email, $password, $phoneNumber, $doctorType){
    if (!$name || !$username || !$email || !$password || !$phoneNumber || $doctorType) {
        echo json_encode(["success" => false, "message" => "All fields are required."]);
        exit();
    }
}

function checkUserExists($conn, $sql, $types, ...$params) {
    $stmt = $conn->prepare($sql);
    $stmt->bind_param($types, ...$params);
    $stmt->execute();
    $result = $stmt->get_result();

    if ($result->num_rows > 0) {
        return true;
    }
    return false;
}

switch ($action) {
//    Authentication
    case 'patientLogin':
        noEmailOrPassword($email, $password);
        getAllUserData($email, $password, $conn, "Patients");
        break;
    case 'doctorLogin':
        noEmailOrPassword($email, $password);
        getAllUserData($email, $password, $conn, "Doctors");
        break;
    case 'signup':
        noEmailOrPassword($email, $password);
        $sql = "SELECT * FROM `Patients` WHERE `email` = ?";
        if(checkUserExists($conn, $sql, "s", $email)){
            echo json_encode(["success" => false, "message" => "Patient already exists."]);
            exit();
        }

        $sql = "SELECT * FROM `Doctors` WHERE `email` = ?";
        if(checkUserExists($conn, $sql, "s", $email)){
            echo json_encode(["success" => false, "message" => "Doctor already exists."]);
            exit();
        }

        noSignUpInfo($name, $username, $email, $password, $phoneNumber, $doctorType);
        $role = sanitize_input($conn, $input, 'role');

        if($role === 'doctor'){
            $sql = "INSERT INTO `Doctors` (`doctorID`, `doctorName`, `userName`, `email`, `password`, `phoneNumber`, `doctorType`)
                VALUES (NULL, ?, ?, ?, ?, ?, ?)";
            $hashedPassword = password_hash($password, PASSWORD_BCRYPT);
            executeInsertUpdateQuery($conn, $sql, "ssssss", $name, $username, $email, $hashedPassword, $phoneNumber, $doctorType);
        } else {
            $sql = "INSERT INTO `Patients` (`patientID`, `patientName`, `userName`, `email`, `password`, `phoneNumber`)
                VALUES (NULL, ?, ?, ?, ?, ?)";
            $hashedPassword = password_hash($password, PASSWORD_BCRYPT);
            executeInsertUpdateQuery($conn, $sql, "sssss", $name, $username, $email, $hashedPassword, $phoneNumber);
        }
        break;
    case 'getPatient':
        noPatientID($patientID);
        $sql = "SELECT patientName, userName, email FROM `Patients` WHERE `patientID` = ?";
        executeArrayQuery($conn, $sql, "i", $patientID );
        break;
    case 'getDoctors':
        noPatientID($patientID);

        $sql = "
            SELECT DISTINCT d.doctorID, d.doctorName, d.doctorType, d.email, d.phoneNumber
            FROM Doctors d
            LEFT JOIN Documents doc ON d.doctorID = doc.doctorID
            LEFT JOIN Appointments app ON d.doctorID = app.doctorID
            LEFT JOIN Medications med ON d.doctorID = med.doctorID
            WHERE doc.patientID = ? OR app.patientID = ? OR med.patientID = ?";
        executeArrayQuery($conn, $sql, "iii", $patientID, $patientID, $patientID);
        break;
//        get Data related to Patient & Display
    case 'getDocuments':
        $sql = "SELECT * FROM `Documents` WHERE `patientID` = ?";
        $stmt = $conn->prepare($sql);
        $stmt->bind_param("i", $patientID);
        $stmt->execute();
        $result = $stmt->get_result();
        $rows = [];
        while ($row = $result->fetch_assoc()) {
            if (isset($row['documentFile'])) {
                $row['documentFile'] = base64_encode($row['documentFile']);
            }
            $rows[] = $row;
        }
        if ($rows) {
            echo json_encode(["success" => true, "data" => $rows]);
        } else {
            echo json_encode(["success" => false, "message" => "No Documents Found."]);
        }
        $stmt->close();
        break;
    case 'getAppointments':
        getAllPatientTableData($patientID, $conn, "Appointments");
        break;
    case 'getLocations':
        $sql = "SELECT location FROM `Appointments` WHERE `patientID` = ?";
        executeArrayQuery($conn, $sql, "i", $patientID);
        break;
    case 'getMedications':
        getAllPatientTableData($patientID, $conn, "Medications");
        break;
    case 'getNotifications':
        getAllPatientTableData($patientID, $conn, "Notifications");
        break;
    case 'getSymptoms':
        getAllPatientTableData($patientID, $conn, "Symptoms");
        break;
//        Avatar Setter & Getter
    case 'getAvatar':
        noPatientID($patientID);
        $sql = "SELECT avatarPicture FROM `Patients` WHERE `patientID` = ?";
        executeGetImage($conn, $sql, "avatarPicture", "i", $patientID);
        break;
    case 'updateAvatar':
        noPatientID($patientID);
        $sql = "UPDATE `Patients` SET `avatarPicture` = ? WHERE `patientID` = ?";
        executeSetImage($conn, $sql, "bi", $avatarPicture, $patientID);
        break;
//      Search by Name
    case 'searchDocuments':
        $sql = "SELECT * FROM `Documents` WHERE `documentTitle` = ? AND `patientID` = ?";
        executeGetImage($conn, $sql,"documentFile", "si", $documentTitle, $patientID);
        break;
    case 'searchAppointments':
        $sql = "SELECT * FROM `Appointments` WHERE `title` = ? AND `patientID` = ?";
        executeQuery($conn, $sql, "si", $title, $patientID);
        break;
    case 'searchMedications':
        $sql = "SELECT * FROM `Medications` WHERE `medicationName` = ? AND `patientID` = ?";
        executeQuery($conn, $sql, "si", $medicationName, $patientID);
        break;
    case 'searchNotifications':
        $sql = "SELECT * FROM `Notifications` WHERE `subject` = ? AND `patientID` = ?";
        executeQuery($conn, $sql, "si", $subject, $patientID);
        break;
    case 'searchSymptoms':
        $sql = "SELECT * FROM `Symptoms` WHERE `symptomName` = ? AND `patientID` = ?";
        executeQuery($conn, $sql, "si", $symptomName, $patientID);
        break;
    case 'searchContacts':
        $sql = "SELECT * FROM `Doctors` WHERE `doctorName` = ?";
        executeQuery($conn, $sql, "s", $doctorName);
        break;
    case 'insertDocuments':
        $sql = "
            SELECT d.doctorID FROM Doctors d
            WHERE d.doctorID IN (
                SELECT DISTINCT doctorID FROM Documents WHERE patientID = ?
                UNION
                SELECT DISTINCT doctorID FROM Appointments WHERE patientID = ?
                UNION
                SELECT DISTINCT doctorID FROM Medications WHERE patientID = ?
            )";
        $rows = getDoctorIDFromPatientID($conn, $sql, "iii", $patientID, $patientID, $patientID);

        if(!$rows){
            echo json_encode(["success" => false, "message" => "No Doctor Found."]);
            exit();
        }
        foreach ($rows as $row) {
            $sql = "INSERT INTO `Documents` (patientID, doctorID, documentTitle, documentDescription, documentType, documentFile, followUp) VALUES (?,?,?,?,?,?,?)";
            executeSetImage($conn, $sql, "iisssbi", $patientID, $row['doctorID'], $documentTitle, $documentDescription, $documentType, $documentFile, $followUp);
        }
        break;
    case 'insertSymptoms':
        $sql = "
            SELECT d.doctorID FROM Doctors d
            WHERE d.doctorID IN (
                SELECT DISTINCT doctorID FROM Documents WHERE patientID = ?
                UNION
                SELECT DISTINCT doctorID FROM Appointments WHERE patientID = ?
                UNION
                SELECT DISTINCT doctorID FROM Medications WHERE patientID = ?
            )";
        $rows = getDoctorIDFromPatientID($conn, $sql, "iii", $patientID, $patientID, $patientID);

        if(!$rows){
            echo json_encode(["success" => false, "message" => "No Doctor Found."]);
            exit();
        }

        $startDateTime = date("Y-m-d H:i:s", strtotime($startDate));
        foreach ($rows as $row) {
            $sql = "INSERT INTO `Symptoms` (patientID, doctorID, symptomName, symptomDescription, symptomSeverity, startDate) VALUES (?,?,?,?,?,?)";
            executeInsertUpdateQuery($conn, $sql, "iissss", $patientID, $row["doctorID"], $symptomName, $symptomDescription, $symptomSeverity, $startDateTime);
        }
        break;
    case 'setReschedule':
        $sql = "UPDATE `Appointments`
        SET `status` = ?
        WHERE `appointmentID` = ?";
        executeInsertUpdateQuery($conn,$sql, "si", $status, $appointmentID);
        break;

//        Doctor Half
    case 'getPatientData':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "SELECT d.*, n.*, a.*, m.*
            FROM `Documents` d
            LEFT JOIN `Notifications` n ON d.patientID = n.patientID AND d.doctorID = n.doctorID
            LEFT JOIN `Appointments` a ON d.patientID = a.patientID AND d.doctorID = a.doctorID
            LEFT JOIN `Medications` m ON d.patientID = m.patientID AND d.doctorID = m.doctorID
            WHERE d.patientID = ? AND d.doctorID = ?";

        executeArrayQuery($conn, $sql, "ii", $insertPatientID, $doctorID);
        break;
    case 'getDoctorDocuments':
        $sql = "SELECT * FROM `Documents` WHERE `doctorID` = ?";
        executeArrayQuery($conn, $sql, "i", $doctorID);
        break;
    case 'getDoctorAppointments':
        $sql = "SELECT * FROM `Appointments` WHERE `doctorID` = ?";
        executeArrayQuery($conn, $sql, "i", $doctorID);
        break;
    case 'getDoctorNotifications':
        $sql = "SELECT * FROM `Notifications` WHERE `doctorID` = ?";
        executeArrayQuery($conn, $sql, "i", $doctorID);
        break;
    case 'getDoctorMedications':
        $sql = "SELECT * FROM `Medications` WHERE `doctorID` = ?";
        executeArrayQuery($conn, $sql, "i", $doctorID);
        break;

    case 'getConnectedPatients':
        $sql = "SELECT DISTINCT patientName FROM Patients p
            LEFT JOIN Appointments a ON p.patientID = a.patientID
            LEFT JOIN Medications m ON p.patientID = m.patientID
            LEFT JOIN Documents d ON p.patientID = d.patientID
            LEFT JOIN Notifications n ON p.patientID = n.patientID
            WHERE a.doctorID = ? OR m.doctorID = ? OR d.doctorID = ? OR n.doctorID = ?;";
        executeArrayQuery($conn, $sql, "iiii", $doctorID, $doctorID, $doctorID, $doctorID);
        break;
    case 'getPatientDocuments':
        $sql = "SELECT * FROM `Documents` WHERE `patientID` = ? AND `doctorID` = ?";
        executeArrayQuery($conn, $sql, "ii", $patientID, $doctorID);
        break;
    case 'getPatientAppointments':
        $sql = "SELECT * FROM `Appointments` WHERE `patientID` = ? AND `doctorID` = ?";
        executeArrayQuery($conn, $sql, "ii", $patientID, $doctorID);
        break;
    case 'getPatientNotifications':
        $sql = "SELECT * FROM `Notifications` WHERE `patientID` = ? AND `doctorID` = ?";
        executeArrayQuery($conn, $sql, "ii", $patientID, $doctorID);
        break;
    case 'getPatientMedications':
        $sql = "SELECT * FROM `Medications` WHERE `patientID` = ? AND `doctorID` = ?";
        executeArrayQuery($conn, $sql, "ii", $patientID, $doctorID);
        break;
    case 'getPatientSymptoms':
        $sql = "SELECT * FROM `Symptoms` WHERE `patientID` = ? AND `doctorID` = ?";
        executeArrayQuery($conn, $sql, "ii", $patientID, $doctorID);
        break;
    case 'insertPatientDocuments':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "INSERT INTO `Documents`
        (patientID, doctorID, documentFile) Values (?,?,?)";

        executeInsertUpdateQuery($conn, $sql, "iis", $insertPatientID, $doctorID, $documentFile);
        break;
    case 'insertPatientAppointments':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "INSERT INTO `Appointments`
        (patientID, doctorID, appointmentDate, appointmentTime, title, appointmentDescription, location)
        Values (?,?,?,?,?,?,?)";

        executeInsertUpdateQuery($conn, $sql, "iisssss", $insertPatientID, $doctorID, $appointmentDate, $appointmentTime, $title, $appointDescription, $location);
        break;
    case 'insertPatientMedications':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "INSERT INTO `Medications`
        (patientID, doctorID, medicationName, strength, type, frequency, timeOfDay,
         medicationDescription) Values (?,?,?,?,?,?,?,?)";

        executeInsertUpdateQuery($conn, $sql, "iissssss", $insertPatientID, $doctorID, $medicationName, $strength, $type, $frequency, $timeOfDay, $medDescription);
        break;
    case 'insertPatientNotifications':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "INSERT INTO `Notifications`
        (patientID, doctorID, notificationTime, subject, notificationDescription)
        Values (?,?,?,?,?)";

        executeInsertUpdateQuery($conn, $sql, "iisss", $insertPatientID, $doctorID, $notificationTime, $subject, $notifDescription);
        break;
    case 'updateDocuments':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "UPDATE `Documents`
        SET `documentFile` = ?
        WHERE `patientID` = ? AND `doctorID` = ?";
        executeInsertUpdateQuery($conn,$sql, "sii", $documentFile, $insertPatientID, $doctorID);
        break;
    case 'updateAppointmentsDate':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "UPDATE `Appointments`
        SET `appointmentDate` = ?
        WHERE `patientID` = ? AND `doctorID` = ?";
        executeInsertUpdateQuery($conn,$sql, "sii", $appointmentDate, $insertPatientID, $doctorID);
        break;
    case 'updateAppointmentsTime':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "UPDATE `Appointments`
        SET `appointmentTime` = ?
        WHERE `patientID` = ? AND `doctorID` = ?";
        executeInsertUpdateQuery($conn,$sql, "sii", $appointmentTime, $insertPatientID, $doctorID);
        break;
    case 'updateNotificationsTime':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "UPDATE `Notifications`
        SET `notificationTime` = ?
        WHERE `patientID` = ? AND `doctorID` = ?";
        executeInsertUpdateQuery($conn,$sql, "sii", $notificationTime, $insertPatientID, $doctorID);
        break;
    case 'updateMedicationsName':
        $insertPatientID = getPatientIDFromName($conn, $patientName);

        $sql = "UPDATE `Medications`
        SET `medicationName` = ?
        WHERE `patientID` = ? AND `doctorID` = ?";
        executeInsertUpdateQuery($conn,$sql, "sii", $medicationName, $insertPatientID, $doctorID);
        break;
    case 'getPatientID':
        if (!$patientName) {
            echo json_encode(["success" => false, "message" => "PHP FILE: Patient Name is required."]);
            exit();
        }

        $sql = "SELECT patientID FROM `Patients` WHERE `patientName` = ?";
        executeQuery($conn,$sql, "s", $patientName);
        break;
    default:
        echo json_encode(["success" => false, "message" => "Invalid action specified."]);
        break;
}

function executeQuery($conn, $sql, $types, ...$params){
    $stmt = $conn->prepare($sql);
    if(!$stmt){
        echo json_encode(["success" => false, "message" => "Data not found."]);
        exit();
    }
    $stmt->bind_param($types, ...$params);
    $stmt->execute();
    $result = $stmt->get_result();
    if(!$result || $result->num_rows == 0){
        echo json_encode(["success" => false, "message" => "Data not found."]);
        exit();
    }
    $info = $result->fetch_assoc();
    echo json_encode(["success" => true, "data" => $info]);
    $stmt->close();
}

function executeArrayQuery($conn, $sql, $types, ...$params) {
    $stmt = $conn->prepare($sql);
    if (!$stmt){
        echo json_encode(["success" => false, "message" => "User not found."]);
        exit();
    }
    $stmt->bind_param($types, ...$params);
    $stmt->execute();
    $result = $stmt->get_result();
    $rows = [];
    while ($row = $result->fetch_assoc()) {
        $rows[] = $row;
    }
    if(!$rows){
        echo json_encode(["success" => false, "message" => "Data not found."]);
        exit();
    }
    echo json_encode(["success" => true, "data" => $rows]);
    $stmt->close();
}

function executeInsertUpdateQuery($conn, $sql, $types, ...$params) {
    $stmt = $conn->prepare($sql);
    if(!$stmt){
        echo json_encode(["success" => false, "message" => "Error: " . $conn->error]);
        exit();
    }
    $stmt->bind_param($types, ...$params);
    $stmt->execute();
    echo json_encode(["success" => true, "data" => "Inserted or Updated successfully."]);
    $stmt->close();
}

function getAllPatientTableData($patientID, $conn, $tableName){
    noPatientID($patientID);
    if($tableName == "Appointments"){
        $sql = "SELECT DISTINCT * FROM " . $tableName . " WHERE `patientID` = ? ORDER BY `appointmentDate` , `appointmentTime`";
    } else {
        $sql = "SELECT DISTINCT * FROM " . $tableName . " WHERE `patientID` = ?";
    }
    $stmt = $conn->prepare($sql);
    if(!$stmt){
        echo json_encode(["success" => false, "message" => "Error: " . $conn->error]);
        exit();
    }
    $stmt->bind_param("i", $patientID);
    $stmt->execute();
    $result = $stmt->get_result();
    $rows = [];
    while ($row = $result->fetch_assoc()) {
        $rows[] = $row;
    }
    echo json_encode(["success" => true, "data" => $rows]);
    $stmt->close();
}

function getAllUserData($email, $password, $conn, $tableName){
    $sql = "SELECT *  FROM " . $tableName . " WHERE email = ?";
    $stmt = $conn->prepare($sql);
    $stmt->bind_param("s", $email);
    $stmt->execute();
    $result = $stmt->get_result();
    $data = $result->fetch_assoc();
    if (!$data) {
        echo json_encode(["success" => false, "message" => "Invalid Email or Password."]);
        exit();
    }
    if (!password_verify($password, $data['password'])) {
        echo json_encode(["success" => false, "message" => "Invalid Password."]);
        exit();
    }
    if ($tableName === "Patients" && !empty($data['avatarPicture'])) {
        $data['avatarPicture'] = base64_encode($data['avatarPicture']);
    }
    echo json_encode(["success" => true, "data" => $data]);
    $stmt->close();
}

function getDoctorIDFromPatientID($conn, $sql, $types, ...$params){
    $stmt = $conn->prepare($sql);
    if (!$stmt){
        echo json_encode(["success" => false, "message" => "User not found."]);
        exit();
    }
    $stmt->bind_param($types, ...$params);
    $stmt->execute();
    $result = $stmt->get_result();
    $rows = [];
    while ($row = $result->fetch_assoc()) {
        $rows[] = $row;
    }
    if(!$rows){
        echo json_encode(["success" => false, "message" => "Data not found."]);
        exit();
    }
    $stmt->close();
    return $rows;
}

function executeGetImage($conn, $sql, $imageName, $types, ...$params){
    $stmt = $conn->prepare($sql);
    $stmt->bind_param($types, ...$params);
    $stmt->execute();
    $result = $stmt->get_result();
    $row = $result->fetch_assoc();

    if(!$row){
        echo json_encode(["success" => false, "message" => "Data Not Found."]);
        exit;
    }
    if (!empty($row[$imageName])) {
        $row[$imageName] = base64_encode($row[$imageName]);
    }
    echo json_encode(["success" => true, "data" => $row]);
    $stmt->close();
}

function executeSetImage($conn, $sql, $types, ...$params){
    $stmt = $conn->prepare($sql);
    if(!$stmt){
        echo json_encode(["success" => false, "message" => "Error: " . $stmt->error]);
        exit();
    }
    $stmt->bind_param($types, ...$params);
    foreach ($params as $index => $param) {
        if ($types[$index] === 'b') {
            $stmt->send_long_data($index, $param);
        }
    }
    if($stmt->execute()){
        echo json_encode(["success" => true, "data" => "Image updated successfully."]);
    } else {
        echo json_encode(["success" => false, "message" => "Error: " . $stmt->error]);
    }

    $stmt->close();
}

function getPatientIDFromName($conn, $patientName){
    $sql = "SELECT patientID FROM `Patients` WHERE `patientName` = ?";
    $stmt = $conn->prepare($sql);
    if(!$stmt){
        echo json_encode(["success" => false, "message" => "Data not found."]);
        exit();
    }
    $stmt->bind_param("s", $patientName);
    $stmt->execute();
    $result = $stmt->get_result();
    if(!$result || $result->num_rows > 0){
        echo json_encode(["success" => false, "message" => "Data not found."]);
        exit();
    }
    $info = $result->fetch_assoc();
    return $info['patientID'];
}
$conn->close();

