import {router} from "expo-router";
import {useEffect} from "react";

export function monitorUser(patientID, doctorID) {
    useEffect(() => {
        if (patientID) {
            pushHome();
        }
    }, [patientID]);

    useEffect(() => {
        if (doctorID) {
            pushDoctor();
        }
    }, [doctorID]);
}

export const pushLogin = () => {
    router.push('/login')
};

export function pushRegister(){
    router.push('/signup')
}

export const pushHome = () => {
    router.push('/home')
};

export const pushIndex = () => {
    router.push('/')
};

export const pushDoctor = () => {
    router.push('/doctor')
};

export const pushDoctorInsert = () => {
    router.push('/doctorInsert')
};

export const pushDoctorUpdate = () => {
    router.push('/doctorUpdate')
};

export function logOutPatient(patientID, setPatientID){
    setPatientID(null);
    console.log('Logged out, patientID reset.', patientID);
    pushIndex();
}

export function logOutDoctor(setDoctorID){
    setDoctorID(null);
    console.log('Logged out, doctorID reset.');
    pushIndex();
}
