import React, {createContext, useContext, useState} from "react";

type DoctorObject = {
    doctorID;
    setDoctorID;
};

const DoctorContext = createContext<DoctorObject | undefined>(undefined);

export function DoctorProvider({ children }) {
    const [doctorID, setDoctorID] = useState();

    return (
        <DoctorContext.Provider value={{ doctorID, setDoctorID }}>
            {children}
        </DoctorContext.Provider>
    );
}

export function useDoctor() {
    const context = useContext(DoctorContext);
    if (!context) {
        throw new Error("useDoctor must be used within a DoctorProvider");
    }
    return context;
}
