import React, {createContext, useContext, useState} from "react";

type PatientObject = {
    patientID;
    setPatientID;
};

const PatientContext = createContext<PatientObject | undefined>(undefined);

export function PatientProvider({ children }){
    const [patientID, setPatientID] = useState();

    return (
        <PatientContext.Provider value={{ patientID, setPatientID }}>
            {children}
        </PatientContext.Provider>
    );
}

export function usePatient() {
    const context = useContext(PatientContext);
    if (!context) {
        throw new Error("usePatient must be used within a PatientProvider");
    }
    return context;
}
