# Project

## Project status
This Project will be ongoing until 1st April 2025.

## Name
The name of this project is "Apps to support management of multiple healthcare appointments & documentation".  
[A University of Strathclyde 4th Year Undergraduate Final Project]

## Description
This React Native app built with the Expo Framework is used to provide a mobile healthcare app catered to chronic patients with emphasis on the management of their medical documents and appointments.

Main Features:
- Scrollable Views
- Displayed Content
- Searchable Content
- Login
- Sign Up
- Drawer Navigation
- Centralised Color Scheme
- Database Backend
- PHP Middleman
- Jest Testing

Patient Screen Specific:
- Document Upload and Display
- Appointments
    - Calendar View
    - Calendar Event Management
    - Appointment Reschedule
    - Appointment Cancellation
- Contacts
    - Message Doctors
    - Call Doctors
    - Video call Doctors
- Symptom Tracker
- Education Section (Google)
- Location
    - Map View
    - 2 Map Markers
    - Automatic Route Calculation
    - Selectable Route Types i.e. Driving, Biking etc.

Doctor Screen Specific:
- Doctor Home Displays Connected Patient Information
- Doctor Inserts Data
- Doctor Updates Data

## Visuals
<img src="Project/assets/images/LoginGIF.gif" width="20%" alt="LoginGIF"/>
<img src="Project/assets/images/FeaturesGIF.gif" width="20%" alt="FeaturesGIF"/>
<img src="Project/assets/images/SignUpGIF.gif" width="20%" alt="SignUpGIF"/>
<img src="Project/assets/images/DoctorLoginGIF.gif" width="20%" alt="DoctorLoginGIF"/>

LoginView      |       FeaturesView       |      SignUpView       |      DoctorLoginView

## Installation
1. Clone this gitlab repository.  
2. Open the terminal.  
3. Run the following commands in the terminal:  
    a. cd Project <- Navigate to Project folder.  
    b. npm install <- Install dependencies.  
    c. npm start <- Start Expo.  
    d. s <- To switch to Expo Go.  
4. Downlaod Expo Go on your mobile device.  
5. In the terminal with Expo Go, scan the generated QR Code or enter the link.  
6. Enter the following credentials into the mobile application on Expo Go.  

Patient Login:  
Email:      tom.holland@example.com  
password:   Sp//der  

Doctor Login:  
Email:      lisa.cuddy@example.com  
Password:   inCharge  

Expo may request permissions for the:
- Camera
- Media Gallery
- Device Location

## Known issues
- Search results show even if a different user signs in.
- Doctor Sign Up is not working.
- Doctor Inserts may or may not be working.
- Doctor Update Information Button not working.

## Support
Any issues should be put into a forum but for now can be put into a text file at the project root.

## Authors and acknowledgment
Author: Abdullah Butt  
Project Researcher: Lisa McCann  
Project Supervisor: Leila Shila Shafti  
2nd Marker: Allais Guillaume  